package com.ejie.ab79.dao.preguntasRespuestas;

import com.ejie.ab79.model.REST.servicioWeb.FicheroRespuestaProtocolo;
import com.ejie.ab79.model.preguntasRespuestas.FicherosAdjPro;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;
import javax.sql.DataSource;
import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

/**
 * FicherosAdjProDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class FicherosAdjProDaoImpl implements FicherosAdjProDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDFICHEROSADJPRO", "IDRESPUESTAPROTOCOLO",
			"TIPOFICHEROADJUNTO", "NOMBREFICHEROADJUNTO", "IDDOCUMENTOSUBIDO", "FICHEROADJUNTO", "FECHAREGISTRO",
			"USUARIOREGISTRO", "FECHAULTMODIFICACION", "USUARIOULTMODIFICACION" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<FicherosAdjPro> rwMap = new RowMapper<FicherosAdjPro>() {
		public FicherosAdjPro mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			FicherosAdjPro ficheroAdjPro = new FicherosAdjPro();
			ficheroAdjPro.setIdFicherosAdjPro(resultSet.getInt("IDFICHEROSADJPRO"));
			ficheroAdjPro.setIdRespuestaProtocolo(resultSet.getInt("IDRESPUESTAPROTOCOLO"));
			ficheroAdjPro.setTipoFicheroAdjunto(resultSet.getInt("TIPOFICHEROADJUNTO"));
			ficheroAdjPro.setNombreFicheroAdjunto(resultSet.getString("NOMBREFICHEROADJUNTO"));
			ficheroAdjPro.setOidPid(resultSet.getString("OIDPID"));
			ficheroAdjPro.setIdDocumentoSubido(resultSet.getInt("IDDOCUMENTOSUBIDO"));
			ficheroAdjPro.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			ficheroAdjPro.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			ficheroAdjPro.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			ficheroAdjPro.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));
			ficheroAdjPro.setIdDocumentoMovil(resultSet.getString("IDDOCUMENTOMOVIL"));

			return ficheroAdjPro;
		}
	};

	private RowMapper<FicherosAdjPro> rwMapPK = new RowMapper<FicherosAdjPro>() {
		public FicherosAdjPro mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new FicherosAdjPro(resultSet.getInt("IDFICHEROSADJPRO"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<FicherosAdjPro>> rwMapJerarquia = new RowMapper<JerarquiaDto<FicherosAdjPro>>() {
		public JerarquiaDto<FicherosAdjPro> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			FicherosAdjPro ficheroAdjPro = new FicherosAdjPro();
			ficheroAdjPro.setIdFicherosAdjPro(resultSet.getInt("IDFICHEROSADJPRO"));
			ficheroAdjPro.setIdRespuestaProtocolo(resultSet.getInt("IDRESPUESTAPROTOCOLO"));
			ficheroAdjPro.setTipoFicheroAdjunto(resultSet.getInt("TIPOFICHEROADJUNTO"));
			ficheroAdjPro.setNombreFicheroAdjunto(resultSet.getString("NOMBREFICHEROADJUNTO"));
			ficheroAdjPro.setOidPid(resultSet.getString("OIDPID"));
			ficheroAdjPro.setIdDocumentoSubido(resultSet.getInt("IDDOCUMENTOSUBIDO"));
			ficheroAdjPro.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			ficheroAdjPro.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			ficheroAdjPro.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			ficheroAdjPro.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));
			ficheroAdjPro.setIdDocumentoMovil(resultSet.getString("IDDOCUMENTOMOVIL"));

			JerarquiaDto<FicherosAdjPro> jerarquia = new JerarquiaDto<FicherosAdjPro>();
			jerarquia.setModel(ficheroAdjPro);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	private RowMapper<FicheroRespuestaProtocolo> rwMapFicherosREST = new RowMapper<FicheroRespuestaProtocolo>() {
		public FicheroRespuestaProtocolo mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			FicheroRespuestaProtocolo ficheroRespuestaProtocolo = new FicheroRespuestaProtocolo();
			ficheroRespuestaProtocolo.setIdFichero(resultSet.getInt("idfichero"));
			ficheroRespuestaProtocolo.setIdPreguntaProtocolo(resultSet.getInt("idpreguntaprotocolo"));
			ficheroRespuestaProtocolo.setTipoFichero(resultSet.getInt("tipofichero"));
			ficheroRespuestaProtocolo.setNombreFichero(resultSet.getString("NOMBREFICHEROADJUNTO"));
			ficheroRespuestaProtocolo.setOid(resultSet.getString("OIDPID"));

			return ficheroRespuestaProtocolo;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the FicherosAdjPro table.
	 *
	 * @param ficherosadjpro
	 *            FicherosAdjPro
	 * @return FicherosAdjPro
	 */
	public FicherosAdjPro add(FicherosAdjPro ficherosadjpro) {
		String query = "INSERT INTO FICHEROS_ADJ_PRO (ID_FICHEROS_ADJ_PRO, ID_RESPUESTA_PROTOCOLO, TIPO_FICHERO_ADJUNTO, ID_DOCUMENTO_SUBIDO, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (S_AB7918T00.NEXTVAL,?,?,?,sysdate,?)";
		this.jdbcTemplate.update(query, ficherosadjpro.getIdRespuestaProtocolo(),
				ficherosadjpro.getTipoFicheroAdjunto(), ficherosadjpro.getIdDocumentoSubido(),
				ficherosadjpro.getUsuarioRegistro());
		return ficherosadjpro;
	}

	/**
	 * Updates a single row in the FicherosAdjPro table.
	 *
	 * @param ficherosadjpro
	 *            FicherosAdjPro
	 * @return FicherosAdjPro
	 */
	public FicherosAdjPro update(FicherosAdjPro ficherosadjpro) {
		String query = "UPDATE FICHEROS_ADJ_PRO SET ID_RESPUESTA_PROTOCOLO=?, TIPO_FICHERO_ADJUNTO=?, ID_DOCUMENTO_SUBIDO=?, FECHA_ULTMODIFICACION=sysdate, USUARIO_ULTMODIFICACION=? WHERE ID_FICHEROS_ADJ_PRO=?";
		this.jdbcTemplate.update(query, ficherosadjpro.getIdRespuestaProtocolo(),
				ficherosadjpro.getTipoFicheroAdjunto(), ficherosadjpro.getIdDocumentoSubido(),
				ficherosadjpro.getUsuarioUltmodificacion(), ficherosadjpro.getIdFicherosAdjPro());
		return ficherosadjpro;
	}

	/**
	 * Finds a single row in the FicherosAdjPro table.
	 *
	 * @param ficherosadjpro
	 *            FicherosAdjPro
	 * @return FicherosAdjPro
	 */
	@Transactional(readOnly = true)
	public FicherosAdjPro find(FicherosAdjPro ficherosadjpro) {
		String query = "SELECT t1.ID_FICHEROS_ADJ_PRO IDFICHEROSADJPRO, t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO, t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO, t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION FROM FICHEROS_ADJ_PRO t1, DOCUMENTOS_SUBIDOS t2 WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) AND t1.ID_FICHEROS_ADJ_PRO = ?  ";

		List<FicherosAdjPro> ficherosadjproList = this.jdbcTemplate.query(query, this.rwMap,
				ficherosadjpro.getIdFicherosAdjPro());
		return (FicherosAdjPro) DataAccessUtils.uniqueResult(ficherosadjproList);
	}

	@Override
	public List<FicherosAdjPro> findFicheros() {
		String query = "SELECT t1.ID_FICHEROS_ADJ_PRO IDFICHEROSADJPRO, t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO, t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO, t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION FROM FICHEROS_ADJ_PRO t1, DOCUMENTOS_SUBIDOS t2 WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) ORDER BY t1.TIPO_FICHERO_ADJUNTO ASC ";

		return this.jdbcTemplate.query(query, this.rwMap);
	}

	/**
	 * Busca los ficheros_adj_pro en base a un idRespuesta
	 * 
	 * @param idRespuesta
	 *            Integer
	 * @return List<FicherosAdjPro>
	 */
	@Override
	public List<FicherosAdjPro> findFicherosByIdRespuesta(Integer idRespuesta) {
		String query = "SELECT t1.ID_FICHEROS_ADJ_PRO IDFICHEROSADJPRO, t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO, t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO, t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION FROM FICHEROS_ADJ_PRO t1, DOCUMENTOS_SUBIDOS t2 WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) AND ID_RESPUESTA_PROTOCOLO = ?";

		return this.jdbcTemplate.query(query, this.rwMap, idRespuesta);
	}

	/**
	 * Removes a single row in the FicherosAdjPro table.
	 *
	 * @param ficherosadjpro
	 *            FicherosAdjPro
	 * @return
	 */
	public void remove(FicherosAdjPro ficherosadjpro) {
		String query = "DELETE FROM FICHEROS_ADJ_PRO WHERE ID_FICHEROS_ADJ_PRO=?";
		this.jdbcTemplate.update(query, ficherosadjpro.getIdFicherosAdjPro());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<FicherosAdjPro> getMultiple(FicherosAdjPro filterFicherosAdjPro, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterFicherosAdjPro, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, FicherosAdjPro.class, params,
				"ID_FICHEROS_ADJ_PRO");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the FicherosAdjPro table.
	 *
	 * @param ficherosadjpro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<FicherosAdjPro>
	 */
	@Transactional(readOnly = true)
	public List<FicherosAdjPro> findAll(FicherosAdjPro ficherosadjpro, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_FICHEROS_ADJ_PRO IDFICHEROSADJPRO,t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO,t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO,t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		query.append("FROM FICHEROS_ADJ_PRO t1, DOCUMENTOS_SUBIDOS t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(ficherosadjpro);
		StringBuilder where = new StringBuilder(" WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, FicherosAdjProDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<FicherosAdjPro>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the FicherosAdjPro table using like.
	 *
	 * @param ficherosadjpro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<FicherosAdjPro>
	 */
	@Transactional(readOnly = true)
	public List<FicherosAdjPro> findAllLike(FicherosAdjPro ficherosadjpro, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_FICHEROS_ADJ_PRO IDFICHEROSADJPRO,t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO,t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO,t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		query.append("FROM FICHEROS_ADJ_PRO t1, DOCUMENTOS_SUBIDOS t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(ficherosadjpro, startsWith);
		StringBuilder where = new StringBuilder(" WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, FicherosAdjProDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<FicherosAdjPro>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<FicheroRespuestaProtocolo> findFicherosREST(Integer idInspeccion) {
		String query = "SELECT t1.id_ficheros_adj_pro idfichero, t4.id_pregunta_protocolo idpreguntaprotocolo, t1.tipo_fichero_adjunto tipofichero, t3.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t3.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO FROM ficheros_adj_pro t1, respuestas_protocolo t2, DOCUMENTOS_SUBIDOS t3, REL_PRO_PRE t4 WHERE t1.ID_DOCUMENTO_SUBIDO = t3.ID_DOCUMENTO_SUBIDO(+) AND t2.id_respuesta_protocolo = t1.id_respuesta_protocolo AND t2.ID_REL_PRO_PRE = t4.ID_REL_PRO_PRE AND t2.id_inspeccion = ?";

		return (List<FicheroRespuestaProtocolo>) this.jdbcTemplate.query(query, this.rwMapFicherosREST, idInspeccion);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the FicherosAdjPro table.
	 *
	 * @param ficherosadjpro
	 *            FicherosAdjPro
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(FicherosAdjPro ficherosadjpro) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM FICHEROS_ADJ_PRO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(ficherosadjpro);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the FicherosAdjPro table using like.
	 *
	 * @param ficherosadjpro
	 *            FicherosAdjPro
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(FicherosAdjPro ficherosadjpro, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM FICHEROS_ADJ_PRO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(ficherosadjpro, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of FicherosAdjPro selected for rup_table
	 *
	 * @param ficherosadjpro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<FicherosAdjPro>>
	 */
	@Override
	public List<TableRowDto<FicherosAdjPro>> reorderSelection(FicherosAdjPro ficherosadjpro,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_FICHEROS_ADJ_PRO IDFICHEROSADJPRO,t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO,t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO,t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FICHERO_ADJUNTO FICHEROADJUNTO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM FICHEROS_ADJ_PRO t1, DOCUMENTOS_SUBIDOS t2 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(ficherosadjpro, startsWith);
		StringBuilder where = new StringBuilder(" WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, FicherosAdjPro.class,
				filterParamList, "ID_FICHEROS_ADJ_PRO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<FicherosAdjPro>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            FicherosAdjPro
	 * @param searchParams
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<FicherosAdjPro>>
	 */
	@Override
	public List<TableRowDto<FicherosAdjPro>> search(FicherosAdjPro filterParams, FicherosAdjPro searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_FICHEROS_ADJ_PRO IDFICHEROSADJPRO,t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO,t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO,t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FICHERO_ADJUNTO FICHEROADJUNTO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM FICHEROS_ADJ_PRO t1, DOCUMENTOS_SUBIDOS t2 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, FicherosAdjPro.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_FICHEROS_ADJ_PRO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<FicherosAdjPro>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterficherosadjpro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(FicherosAdjPro filterficherosadjpro, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_FICHEROS_ADJ_PRO IDFICHEROSADJPRO,t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO,t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO,t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FICHERO_ADJUNTO FICHEROADJUNTO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM FICHEROS_ADJ_PRO t1, DOCUMENTOS_SUBIDOS t2 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterficherosadjpro, startsWith);
		StringBuilder where = new StringBuilder(" WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, FicherosAdjPro.class,
				query, params, "ID_FICHEROS_ADJ_PRO");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical FicherosAdjPro table.
	 *
	 * @param filterFicherosAdjPro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<FicherosAdjPro>>
	 */
	@Override
	public List<JerarquiaDto<FicherosAdjPro>> findAllLikeJerarquia(FicherosAdjPro filterFicherosAdjPro,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_FICHEROS_ADJ_PRO IDFICHEROSADJPRO,t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO,t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO,t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FICHERO_ADJUNTO FICHEROADJUNTO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM FICHEROS_ADJ_PRO t1 ");
		List<String> from = new ArrayList<String>();
		from.add("FICHEROS_ADJ_PRO");
		from.add("DOCUMENTOS_SUBIDOS");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterFicherosAdjPro, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_FICHEROS_ADJ_PRO", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					FicherosAdjProDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterFicherosAdjPro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(FicherosAdjPro filterFicherosAdjPro, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM FICHEROS_ADJ_PRO t1 ");
		List<String> from = new ArrayList<String>();
		from.add("FICHEROS_ADJ_PRO");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterFicherosAdjPro, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_FICHEROS_ADJ_PRO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterFicherosAdjPro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<FicherosAdjPro>>
	 */
	@Override
	public List<TableRowDto<FicherosAdjPro>> findAllChild(FicherosAdjPro filterFicherosAdjPro,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM FICHEROS_ADJ_PRO t1 ");
		List<String> from = new ArrayList<String>();
		from.add("FICHEROS_ADJ_PRO");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterFicherosAdjPro, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_FICHEROS_ADJ_PRO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<FicherosAdjPro>(this.rwMapPK, "ID_FICHEROS_ADJ_PRO"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the FicherosAdjPro entity
	 *
	 * @param ficherosadjpro
	 *            FicherosAdjPro Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(FicherosAdjPro ficherosadjpro) {

		StringBuilder where = new StringBuilder(FicherosAdjProDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (ficherosadjpro != null && ficherosadjpro.getIdFicherosAdjPro() != null) {
			where.append(" AND t1.ID_FICHEROS_ADJ_PRO = ?");
			params.add(ficherosadjpro.getIdFicherosAdjPro());
		}
		if (ficherosadjpro != null && ficherosadjpro.getIdRespuestaProtocolo() != null) {
			where.append(" AND t1.ID_RESPUESTA_PROTOCOLO = ?");
			params.add(ficherosadjpro.getIdRespuestaProtocolo());
		}
		if (ficherosadjpro != null && ficherosadjpro.getTipoFicheroAdjunto() != null) {
			where.append(" AND t1.TIPO_FICHERO_ADJUNTO = ?");
			params.add(ficherosadjpro.getTipoFicheroAdjunto());
		}
		if (ficherosadjpro != null && ficherosadjpro.getNombreFicheroAdjunto() != null) {
			where.append(" AND t2.NOMBRE_DOCUMENTO = ?");
			params.add(ficherosadjpro.getNombreFicheroAdjunto());
		}
		if (ficherosadjpro != null && ficherosadjpro.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(ficherosadjpro.getFechaRegistro());
		}
		if (ficherosadjpro != null && ficherosadjpro.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(ficherosadjpro.getUsuarioRegistro());
		}
		if (ficherosadjpro != null && ficherosadjpro.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(ficherosadjpro.getFechaUltmodificacion());
		}
		if (ficherosadjpro != null && ficherosadjpro.getUsuarioUltmodificacion() != null) {
			where.append(" AND t1.USUARIO_ULTMODIFICACION = ?");
			params.add(ficherosadjpro.getUsuarioUltmodificacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the FicherosAdjPro entity
	 *
	 * @param ficherosadjpro
	 *            FicherosAdjPro Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(FicherosAdjPro ficherosadjpro, Boolean startsWith) {

		StringBuilder where = new StringBuilder(FicherosAdjProDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();
		where.append(" AND t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+)");

		if (ficherosadjpro != null && ficherosadjpro.getIdFicherosAdjPro() != null) {
			where.append(" AND t1.ID_FICHEROS_ADJ_PRO = ?");
			params.add(ficherosadjpro.getIdFicherosAdjPro());
		}
		if (ficherosadjpro != null && ficherosadjpro.getIdRespuestaProtocolo() != null) {
			where.append(" AND t1.ID_RESPUESTA_PROTOCOLO = ?");
			params.add(ficherosadjpro.getIdRespuestaProtocolo());
		}
		if (ficherosadjpro != null && ficherosadjpro.getTipoFicheroAdjunto() != null) {
			where.append(" AND t1.TIPO_FICHERO_ADJUNTO = ?");
			params.add(ficherosadjpro.getTipoFicheroAdjunto());
		}
		if (ficherosadjpro != null && ficherosadjpro.getNombreFicheroAdjunto() != null) {
			where.append(" AND UPPER(t2.NOMBRE_DOCUMENTO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(ficherosadjpro.getNombreFicheroAdjunto().toUpperCase() + "%");
			} else {
				params.add("%" + ficherosadjpro.getNombreFicheroAdjunto().toUpperCase() + "%");
			}
			where.append(" AND t2.NOMBRE_DOCUMENTO IS NOT NULL");
		}
		if (ficherosadjpro != null && ficherosadjpro.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(ficherosadjpro.getFechaRegistro());
		}
		if (ficherosadjpro != null && ficherosadjpro.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(ficherosadjpro.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + ficherosadjpro.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (ficherosadjpro != null && ficherosadjpro.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(ficherosadjpro.getFechaUltmodificacion());
		}
		if (ficherosadjpro != null && ficherosadjpro.getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t1.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(ficherosadjpro.getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + ficherosadjpro.getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_ULTMODIFICACION IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
